<div class="events-list mb-5">

  <div class="container">

    <h1 class="mat-h1">Kalendarz firmowy</h1>
    <mat-divider class="mb-2"></mat-divider>

    <mat-card>
      <div class="search-div">
        <ng-container *ngIf="currentUser?.permissions?.canEditEvents">
          <button mat-raised-button (click)="onCreateEventDialog()">
            <mat-icon>add</mat-icon>
            Dodaj nowe wydarzenie
          </button>
        </ng-container>
        <mat-form-field class="search-form-field">
          <input matInput [(ngModel)]="searchKey" placeholder="Wyszukaj wydarzenie po wybranej frazie"
                 autocomplete="off"
                 (keyup)="applyFilter()">
          <button mat-button matSuffix mat-icon-button aria-label="Wyczyść" *ngIf="searchKey" (click)="onSearchClear()">
            <mat-icon>close</mat-icon>
          </button>
        </mat-form-field>
      </div>

      <div class="mat-elevation-z8">
        <mat-table [dataSource]="eventsDataSource" matSort>

          <ng-container matColumnDef="name">
            <mat-header-cell *matHeaderCellDef>Nazwa</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.name}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="startDate">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Początek</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.startDate | date: 'M/d/yyyy'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="endDate">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Koniec</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.endDate | date: 'M/d/yyyy'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="time">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Godzina</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.time}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="participant">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Uczestnik</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.participant?.data?.firstName}} {{element?.participant?.data?.lastName}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="place">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Miejsce</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.place}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="isCanceled">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Odwołane?</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.isCanceled ? 'Tak' : 'Nie'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="createdAt">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Utworzono</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.createdAt | date: 'M/d/yyyy, h:mm'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="updatedAt">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Edytowano</mat-header-cell>
            <mat-cell *matCellDef="let element">{{element?.updatedAt | date: 'M/d/yyyy, h:mm'}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="createdBy">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Utworzono przez</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.createdBy?.data?.firstName}} {{element?.createdBy?.data?.lastName}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="updatedBy">
            <mat-header-cell *matHeaderCellDef mat-sort-header>Edytowano przez</mat-header-cell>
            <mat-cell
              *matCellDef="let element">{{element?.updatedBy?.data?.firstName}} {{element?.updatedBy?.data?.lastName}}</mat-cell>
          </ng-container>

          <ng-container matColumnDef="actions">
            <mat-header-cell *matHeaderCellDef></mat-header-cell>
            <mat-cell *matCellDef="let row">
              <ng-container *ngIf="currentUser?.permissions?.canEditEvents">
                <button mat-icon-button (click)="onUpdateEventDialog(row)">
                  <mat-icon matTooltip="Edytuj wydarzenie">edit</mat-icon>
                </button>
                <ng-container *ngIf="!row?.isCanceled">
                  <button mat-icon-button color="warn" (click)="onCancelEvent(row)">
                    <mat-icon matTooltip="Odwołaj wydarzenie">delete_outline</mat-icon>
                  </button>
                </ng-container>
              </ng-container>
            </mat-cell>
          </ng-container>

          <ng-container matColumnDef="loading">
            <mat-footer-cell *matFooterCellDef>
              Ładowanie danych...
            </mat-footer-cell>
          </ng-container>
          <ng-container matColumnDef="noData">
            <mat-footer-cell *matFooterCellDef>
              Aktualnie brak danych o zaplanowanych wydarzeniach.
            </mat-footer-cell>
          </ng-container>

          <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
          <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>

          <mat-footer-row *matFooterRowDef="['loading']"
                          [ngClass]="{'none':eventsDataSource!=null}"></mat-footer-row>
          <mat-footer-row *matFooterRowDef="['noData']"
                          [ngClass]="{'none':!(eventsDataSource!=null && eventsDataSource.data.length==0)}"></mat-footer-row>

        </mat-table>
        <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]" [pageSize]="10" showFirstLastButtons></mat-paginator>
      </div>
    </mat-card>

  </div>
</div>
